**free

// RPG BATTLE DEV 2024 - Manche 1 - Epreuve 1 - Du 6 au 8 novembre 2024

// Contexte :
//  Le fichier base de données TEAMLIB/FILM contient une liste des films

// Objectif :
//  Afficher par catégorie le film ayant le plus de vues et les afficher (DSPLY) par ordre
//  alphabétique.
//  Mise en forme du résultat :
//   DSPLY Comedie
//   DSPLY Les bronzes
//   DSPLY 0094558100
//   DSPLY Fantastique
//   DSPLY Avatar
//   DSPLY 0985452365

// Consignes :
//  1. Ne pas modifier les lignes de code déjà présentes, ajouter vos lignes de code nécessaires
//  2. Utiliser uniquement des instructions RPG natives (pas de SQL, pas d'appels d'API ...)

// Critères d'évaluation :
//  1. Le résultat doit être celui demandé
//  2. Le code présent ne doit pas être modifié
//  3. Le code doit être le plus simple, le plus lisible possible et le plus optimisé
//  4. Le programme doit s'appeler E1 dans votre bibliothèque TEAMXX

// -----------------------------------------------------------------------------
// Votre profil IBM i : TEAMXX
// -----------------------------------------------------------------------------

ctl-opt actgrp(*new) alwnull(*no);
ctl-opt extbinint(*yes) ;

dcl-f film rename(film:ffilm);

// Pour lecture et stockage des données
dcl-ds curFilm likerec(ffilm) inz ;
dcl-ds films   likerec(ffilm) dim(*auto:10) inz ;

// Lecture du fichier des films pour chargement du tableau
read film curFilm;
dow not %eof;
   addFilm(curFilm);
   read film curFilm;
Enddo;

// Affichage du résultat
displayResult();

return ;

// procédure de chargement du tableau
dcl-proc addFilm;
   dcl-s l_index uns(3) inz(0);

   dcl-pi *n;
      p_film likerec(ffilm) const ;
   End-pi;

   l_index = %lookup(p_film.categorie:films(*).categorie);

   select;
      // si la catégorie est dans la liste et que le film a plus de vues
      When l_index > 0 and films(l_index).vues < p_film.vues;
          films(l_index) = p_film ;
      // si la catégorie n'existe pas on la rajoute
      When l_index = 0;
          films(*next)   = p_film;
   Endsl;

End-proc;

// Procédure d'affichage
dcl-proc displayResult;

   // trier par catégorie
   sorta films(*).categorie;

   // Mise en forme et affichage
   for-each curFilm in films;
      DSPLY curFilm.categorie;
      DSPLY curFilm.libelle;
      DSPLY %editc(curFilm.vues:'X') ;
   endfor;

End-proc; 