**free

// RPG BATTLE DEV 2024 - Manche 2 - Epreuve 4 - Du 13 au 15 Novembre 2024

// Contexte :
//  Faire un programme de gestion des stocks
//  Le fichier base de données TEAMLIB/INTERFACE contient le stock de tout l'entrepot au format XML
//  Considérer que ce fichier ne contiendra qu'une seule ligne

// Objectif :
//  Afficher le statut de chaque ligne de stock de la zone A en tenant compte de la règle suivante :
//  Si quantité = 0, afficher          : DSPLY  {Code_Article} STOCK CRITIQUE!
//  Si quantité entre 1 et 4, afficher : DSPLY  {Code_Article} A REAPPROVISIONNER
//  Si quantité >= 5, afficher         : DSPLY  {Code_Article} STOCK OK
//  Remplacer {Code_Article} par le code article
//  Exemple de résultat :
//    DSPLY  Ecran 17" A REAPPROVISIONNER
//    DSPLY  POWER10 STOCK CRITIQUE!

// Consignes :
//  1. Ne pas modifier les lignes de code déjà présentes, ajouter vos lignes de code nécessaires
//  2. Utiliser uniquement des instructions RPG natives (pas de SQL, pas d'appels d'API ...)

// Critères d'évaluation :
//  1. Le résultat doit être celui demandé
//  2. Le code présent ne doit pas être modifié
//  3. Le code doit être le plus simple, le plus lisible possible et le plus optimisé.
//  4. Le programme doit s'appeler E4 dans votre bibliothèque TEAMXX

// -----------------------------------------------------------------------------
// Votre profil IBM i : TEAMXX
// -----------------------------------------------------------------------------

ctl-opt actgrp(*new) ;

dcl-f interface rename(interface:finterface) ;

// Stockage des éléments XML lus
dcl-ds stock dim(*auto :10) qualified ;
   zone             varchar(1);
   dcl-ds article ;
       qte          packed(5:0) ;
       libelle      varchar(20);
   end-ds ;
end-ds ;
// Pour parcours
dcl-ds curStock likeds(stock) ;


// initialisation
clear stock;

// lecture données
read(e) interface;
if %error or %eof(interface) ;
   dsply 'Problème d''accès au données' ;
   return ;
endif ;

// Extraction des infos :
xml-into stock %xml(ligne:'case=any path=entrepot/stock trim=all ' +
                          'allowextra=yes datasubf=libelle' );
// On parcourt, on affiche. Pas de contraine de tri exprimée
for-each curStock in stock ;
    if curStock.zone = 'A' ;
        select curStock.article.qte ;
            when-is 0 ;
                dsply (curStock.article.libelle + ' STOCK CRITIQUE!') ;
            when-in %range(1:4) ;
                dsply (curStock.article.libelle + ' A REAPPROVISIONNER') ;
            other ;
                dsply (curStock.article.libelle + ' STOCK OK') ;
        endsl ;
    endif ;
endfor ;

return ; 